<script>

import UserDataService from "../services/UserDataService";

// eslint-disable-next-line vue/no-export-in-script-setup
export default {
  name: "user-details",
  data() {
    return {
      currentUser: null,
      message: ''
    };
  },
  methods: {
    getUser(uid) {
      UserDataService.get(uid)
          .then(response => {
            this.currentUser = response.data;
            console.log(response.data);
          })
          .catch(e => {
            console.log(e);
          });
    },

    updateUser() {
      UserDataService.update(this.currentUser.uid, this.currentUser)
          .then(response => {
            console.log(response.data);
            this.message = 'The user was updated successfully!';
          })
          .catch(e => {
            console.log(e);
          });
    },

    deleteUser() {
      UserDataService.delete(this.currentUser.uid)
          .then(response => {
            console.log(response.data);
            this.$router.
            push({ name: "users" });
          })
          .catch(e => {
            console.log(e);
          });
    }
  },
  mounted() {
    this.message = '';
    this.getUser(this.$route.params.uid);
  }
};
</script>

<template>
  <div v-if="currentUser" class="edit-form">
    <h4>User</h4>
    <form>
      <div class="form-group">
        <label><strong>Uid:</strong></label>
        {{ currentUser.uid }}
      </div>
      <div class="form-group">
        <label for="name"><strong>Name:</strong></label>
        <input type="text" class="form-control" id="name"
               v-model="currentUser.name"
        />
      </div>
      <div class="form-group">
        <label for="email"><strong>E-Mail:</strong></label>
        <input type="text" class="form-control" id="email"
               v-model="currentUser.email"
        />
      </div>
    </form>
    <button class="m-3 btn btn-sm btn-success" @click="updateUser">
      Update
    </button>
    <button class="m-3 btn btn-sm btn-danger" @click="deleteUser">
      Delete
    </button>
    <router-link
        to="/users/"
        custom
        v-slot="{ navigate }"
    >
      <button
          class="m-3 btn btn-sm btn-info"
          @click="navigate"
          role="link"
      >
        Go back
      </button>
    </router-link>

    <p>{{ message }}</p>
  </div>

  <div v-else>
    <br />
    <p>Please click on a User...</p>
  </div>
</template>

<style>
.edit-form {
  max-width: 300px;
  margin: auto;
}
</style>